# Orchid Information Manager
# This shows a list of not complete orders for the customer.
# Field 1 should be the Customer Number field.
from accpac import *
import eb
import datetime
import locale
import time

orders = None

# init is called when the script is first loaded.
def init(arg):
	pass

def accpacDateToDate(d):
	if d == "0":
		return None
	return datetime.date(int(d[0:4]), int(d[4:6]), int(d[6:8]))

def onRefreshContent():
	global orders
	locale.setlocale(locale.LC_ALL, "")
	eb.clearAll()
	vOEORDH = openView("OE0520", 1)
	vOEORDH.order(2) # customer, ordnumber
	vOEORDH.recordClear()
	vOEORDH.browse("CUSTOMER=\"" + eb.value1 + "\" AND TYPE=1 AND COMPLETE<3", True)

	g = eb.addGrid()
	g.name = "grid"
	col = g.addColumn("Order Number")
	col = g.addColumn("Order Description")
	col = g.addColumn("Expected Ship Date")
	col = g.addColumn("Purchase Order Number")
	col = g.addColumn("Order Total")
	col.align = "RIGHT"
	n = 0
	orders = []
	while vOEORDH.fetch() == 0:
		n = n + 1
		r = g.addRow()
		r.setCell(0, vOEORDH.get("ORDNUMBER"))
		r.setCellColor(0, RGB(0,0,255))
		r.setCell(1, vOEORDH.get("DESC"))
		r.setCell(2, accpacDateToDate(vOEORDH.get("EXPDATE")).strftime("%x"))
		r.setCell(3, vOEORDH.get("PONUMBER"))
		r.setCell(4, "{:,.2f}".format(vOEORDH.get("INVNETWTX")))
		orders.append(vOEORDH.get("ORDUNIQ"))

# Called when you double click / press enter on an item in the grid
def onAction_Open(ctrlName, rowIndex):
	openUI("OE1100", "KEY=" + str(orders[int(rowIndex)]), False)
